<?php


// get variables passed in from do_choose()

	$stored_page = $_GET["page"];
	$stored_template = $_GET["template"];
	$action = $_GET["action"];


// define some useful functions

	function get_file($file, $method, $check_last_modified) { // method can be "http", "filesystem", or "auto" (auto looks at $pre_render_files list)
		GLOBAL $output, $file_missing, $pre_render_files, $script_location;
		GLOBAL $template, $read_page_definitions_from, $latest_mod_date, $latest_mod_date_formatted;
		GLOBAL $check_URL;
		$text = "";
		if (preg_match("/\/(\.\w.*)/", $file)) { // don't read files whose names start with "."
			$text = show_error("Not authorized to read the hidden file named \"$matches[1]\"");
		} else {
			
			// first, figure out if we're going to read over HTTP or through the filesystem...
			if (($method == "")||($method == "auto")) {
				if ($pre_render_files) {
					for ($n=0; $n < count($pre_render_files); $n++) {
						if (strstr($file, $pre_render_files[$n])) { $method = "http"; }
					}
				}
			}
			
			// ...then get the file
			if ($method == "http") {

				// 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "http");

				// in PHP, the next three steps are the same for http or local connections, but it's easier to maintain the
				// different versions of this script if we lay out the conditional nesting the same way in every language
				// hence the repeated code here
				
				// 2) open a connection to the file (in PHP, steps 2, 3 and 5 are shared by the http and filesystem options, so the nesting is different here)
				@$myfile = fopen($file_URL, "r");
				if (! $myfile) {
					$text = show_error("Can't open the file named \"$file\" $check_URL");
					$file_missing = 1;
				} else {
				
					// 3) read the file
					while (!feof($myfile)) { $text .= fread($myfile, 4096); }
					$file_missing = 0;
					
					// 4) close the file connection
					fclose($myfile);
					
				}
	
				//$output .= "<p>reading $file_URL over http<p>";  // debug

			} else {

				// 1) prepare the URL for this type of connection
				$file_URL = absolute_path($file, "filesystem");
				
				// 2) open a connection to the file (in PHP, steps 2, 3 and 5 are shared by the http and filesystem options, so the nesting is different here)
				@$myfile = fopen($file_URL, "r");
				if (! $myfile) {
					$text = show_error("Can't open the file named \"$file\" $check_URL");
					$file_missing = 1;
				} else {
				
					// 3) read the file
					while (!feof($myfile)) { $text .= fread($myfile, 4096); }
					$file_missing = 0;
					
					// 4) for local files, catch the file's modification date (for $read_page_definitions_from and $template, plus content files when the template contains a env_last_modified tag)
					if ($check_last_modified) {
						$mtime = filemtime($file_URL);
						if ($mtime > $latest_mod_date) {
							$latest_mod_date = $mtime;
							$latest_mod_date_formatted = date("Y-m-d - g:i a", $mtime); // h for two-digit hour
						}
					}
	
					// 5) close the file connection
					fclose($myfile);
					
				}
	
				//$output .= "<p>reading $script_location_copy + $file_copy through filesystem<p>"; // debug

			}
				
			// finally, conform all line breaks to avoid cross-platform issues
			// we'd rather conform to Unix line breaks (\n), but that doesn't work in ASP, which doesn't support the s flag in regular expressions
			$text = str_replace("\r\n", "\r", $text); // change DOS to Mac
			$text = str_replace("\n", "\r", $text); // change Unix to Mac

		}
		return $text;
	}
	
	function get_setting($source_text, $setting, $allow_override, $allow_partial) {
		// allow most preferences to be overridden through the argument string
		GLOBAL $output, $settings_used;
		$value = "";
		$setting_no_spaces = $setting;
		$setting_no_spaces = preg_replace("/[ -]/", "_", $setting_no_spaces, -1);
		$settings_used .= "$setting_no_spaces,";
		
		$override = $_GET[$setting_no_spaces];
		if (($allow_override)&&($override != "")) {
			$value = $override;
		} else {
			$source_text = "\r".$source_text; // this makes it easy to make sure settings start on a new line
			if ($allow_partial) {  // this lets us use more verbose labels in the ini file
				if (preg_match("/[^\w]".$setting."[^:\r]*: ([^\r]*)\r*/i", $source_text, $matches)) {
					$value = $matches[1];
				}
			} else {  // this ensures an exact match in the pages file
				if (preg_match("/[^\w]".$setting.": ([^\r]*)\r*/i", $source_text, $matches)) {
					$value = $matches[1];
				}
			}
		}
		if ($value == "0") { $value = 0; } // this ensures that a 0 value will evaluate false in every language
		return $value;
	}
	
	function get_page_names($source) { // return a list of all the page names in a page definitions file
		GLOBAL $output;
		$page_names = Array();
		while (preg_match("/(\w+)\:\s+[\w]+/", $source, $matches)) {
			$this_page_name = $matches[1];
			array_push($page_names, $this_page_name);
			$source = str_replace($this_page_name.":", "", $source);
		}
		return $page_names;
	}

	function get_directory_listing($directory) { // return a list of all the items in the specified directory
		GLOBAL $output;
		if ($dir = opendir(absolute_path($directory, "filesystem"))) {
			$files = Array();
			while ($file = readdir($dir)) {
				if (substr($file, 0, 1) != ".") { array_push($files, $file); } // that gets files that don't start with a dot
			}  
			closedir($dir);
		}
		return $files;
	}
	
	function get_recursive_listing($start_folder, $recursive=0, $filter="") { // return a list of all the files in a given folder, including subfolders
		GLOBAL $output;
		$start_folder = preg_replace("/[\\/\\\]$/", "", $start_folder, 1); // remove a trailing slash
		$file_list = Array();
		$folder_list = Array($start_folder);
		while ($folder_list) {
			$this_folder_path = $folder_list[0];
			$this_folder_items = get_directory_listing($this_folder_path);
			for ($n=0; $n<count($this_folder_items); $n++) {
				$this_item_name = $this_folder_items[$n];
				$this_item_path = $this_folder_path."/".$this_item_name;
 				// if the item name contains a dot, we assume it's a file, if not, we assume it's a directory
 				if (! strstr($this_item_name, ".")) {
 					// we've found a folder; add it to the list of folders to scan
 					if ($recursive) {
						array_push($folder_list, $this_item_path);
					}
				} else if ((!$filter)||(strstr($this_item_name, $filter))) {
					// we've found a file; add it to the list of files to return
					$this_item_path = str_replace($start_folder."/", "", $this_item_path); // make results relative to the start folder, not to the site
					array_push($file_list, $this_item_path);
				}
			}
			array_shift($folder_list); // remove the folder we just scanned from the list
		}
		return $file_list;
	}
	
	function absolute_path($path, $method) { // convert a reference to a file within our site to an absolute URL or filesystem path
		GLOBAL $output, $script_location, $request, $URL_rewriting_flag;
		if ($script_location) { // if this hasn't been set yet, just return the original value

			if ($method == "filesystem") {
			
				$script_location_copy = $script_location;
				$file_copy = $path;
				while (strstr($file_copy, "../")) {
					// this avoids results like contemplate/../templates/default.html
					$script_location_copy = preg_replace("/[^\/]+\/$/", "", $script_location_copy, 1); // remove the last directory name from the script location
					$file_copy = preg_replace("/\.\.\//", "", $file_copy, 1); // remove the first updelim from the filename (in PHP, we need to use preg_replace so we only do one replacement)
				}
				$path = $script_location_copy.$file_copy;
				
			} else {
			
				$thisserver = $_SERVER["HTTP_HOST"];
				if (preg_match("/\/([^=]*\/)contemplate\//i", $request, $matches)) { $thispath = $matches[1]; }
				if (preg_match("/\/([^=]*\/)$URL_rewriting_flag\//i", $request, $matches)) { $thispath = $matches[1]; }
				
				// pass along the authentication information if present
				$login = ($_SERVER["PHP_AUTH_USER"]) ? $_SERVER["PHP_AUTH_USER"].":".$_SERVER["PHP_AUTH_PW"]."@" : "" ; 
				
				$path = str_replace("../", "http://$login$thisserver/$thispath", $path);
				
			}
		
		}
		return $path;
	}

	function show_error($message) { // the only purpose for this here is to prevent the script from halting if one of the shared functions throws an error
		return "Error: ".$message;
	}
	

// set up some error messages that we can use later

	$check_URL = "<br>Hint: Check your page definition";
	$check_embed = "<br>Hint: Check your embed tag";
	$check_field_label = "<br>Hint: Check your content file and remove any formatting tags between the field marker and the field label";
	

// set up some primary variables

	$URL_rewriting_flag = "assembled"; // we'd rather store this in the preferences file, but we need it in order to read the preferences file!

	// figure out the location of the contemplate directory as shown in the browser, and use that as the basis for open commands;
	// this allows us to run the script from a symlink to the real contemplate folder, and paths will be relative to the
	// apparent, rather than the actual, location of assembler.php
	// this will also prevent problems if Windows calculates relative paths from the server root
	$request = (strstr($_SERVER["OS"], "Win")) ? $_SERVER["SCRIPT_NAME"] : ( (strpos($_SERVER["REQUEST_URI"], "?")) ? substr($_SERVER["REQUEST_URI"], 0, strpos($_SERVER["REQUEST_URI"], "?")) : $_SERVER["REQUEST_URI"] ) ;
	$script_location = stripslashes($_SERVER["PATH_TRANSLATED"]);
	$script_location = str_replace("\\", "/", $script_location);
	if (preg_match("/(.*\/)$URL_rewriting_flag\//i", $script_location, $matches)) {
		$script_location = $matches[1]."contemplate/";
	} else {
		$script_location = preg_replace("/(.*\/)[^\/]+/", "$1", $script_location, 1);
	}


// get some preference settings from the preferences file

	$preferences = get_file("../preferences.ini", "filesystem", 0);
	if ($preferences) { $read_page_definitions_from = "../".get_setting($preferences, "read page definitions from", 1, 1); }
	if (($read_page_definitions_from == "../")||($read_page_definitions_from == "")) { $read_page_definitions_from = "../pages.txt"; }
	if ($preferences) { $read_files_recursively = get_setting($preferences, "read files recursively", 1, 1); }
	if ($read_files_recursively === "") { $read_files_recursively = "1"; }
	$read_files_recursively = intval($read_files_recursively);


// set up the HTML page
	
	print "
	
		<html>
	
		<head>
		
			<title>Contemplate</title>
			
			<link rel=stylesheet href=../stylesheet.css type=text/css>
		
		</head>
		
		<body bgcolor=#FFFFFF>
				
			<form name=contemplate>
	
	";
	
	
// print a list of available templates by scannning the templates folder
	
	$templates = get_recursive_listing("../../templates", $read_files_recursively, "");
	$templates_count = count($templates);
			
	if ($action == "template") {
	
		print "<p class=heading>Choose a template with which to build your new page</p>\n\n";
		
		print "<p class=body>\n\n";
		
		for ($i=0; $i<$templates_count; $i++) {
		
			$this_template = $templates[$i];
			$this_template_checked = ($stored_template == $this_template) ? "checked" : "" ;
			print "<input type=radio name=choices onclick=\"parent.set_choice($i,'template','$this_template',0)\" $this_template_checked>\n";
			print "<a href=\"JavaScript:parent.set_choice($i,'template','$this_template',1)\">$this_template</a><br>\n\n";
			
		}
					
		print "</p>\n\n";
	
	}
	
	
// print a list of defined pages by scanning the page definitions file
					
	$pages_file = get_file($read_page_definitions_from, "filesystem", 0);
	$pages = get_page_names($pages_file);
	$pages_count = count($pages);
	
	$definitions = Array();
							
	if (($action == "page")||($action == "edit")||($action == "delete")) {

		if ($action == "page") {
			print "<p class=heading>Choose a page on which to base your new page</p>\n\n";
		} else if ($action == "edit") {
			print "<p class=heading>Choose the page you want to edit</p>\n\n";
		} else {
			print "<p class=heading>Choose the page you want to delete</p>\n\n";
		}
				
		print "<p class=body>\n\n";
		
		for ($i=0; $i<$pages_count; $i++) {
	
			$this_page = $pages[$i];
			$this_page_checked = ($stored_page == $this_page) ? "checked" : "" ;
			print "<input type=radio name=choices onclick=\"parent.set_choice($i,'page','$this_page',0)\" $this_page_checked>\n";
			print "<a href=\"JavaScript:parent.set_choice($i,'page','$this_page',1)\">$this_page</a><br>\n\n";
			
			$this_definition = get_setting($pages_file, $this_page, 0, 0);
			array_push($definitions, $this_definition);
			
			if (($i % 10) == 0) { flush(); } // update the display every tenth time
			
		}
					
		print "</p>\n\n";
		
	}
	
	
// set some variables in JavaScript based on the stuff we scanned above
					
	print "<script language=JavaScript>\n\n";
	
	print "parent.page_names = new Array('";
	print implode("', '", $pages);
	print "');\n";
	
	print "parent.page_definitions = new Array('";
	print implode("', '", $definitions);
	print "');\n\n";
			
	print "parent.template_files = new Array('";
	print implode("', '", $templates);
	print "');\n";

	print "</script>\n\n";


// we're done!

	print "</form>";

	print "</body></html>";

	exit;
